% Test datacheck_mean & wiberg_mean

m = 50;
n = 30;
r = 3;
sigma = 0.01;

% Generate data
U0 = randn(m, r);
V0 = randn(n, r);
mu0 = rand(n, 1);
Y = U0 * V0.' + ones(m,1)*mu0.' + sigma*rand(m, n);
H = ones(m, n);

% Assume band-diagonal nonmissing components
band_width = 3;
for i=1:m
    for j=1:n
        if n/m*i-band_width*r < j && j < n/m*i+band_width*r,
            H(i,j) = 1;
        else
            H(i,j) = 0;
        end
    end
end

%H

% Initial values
Vini = randn(n, r);
mu_ini = randn(n, 1);

disp('Checking the completeness of H...');
data_ok = datacheck_mean(H, r);
disp('done.');
if data_ok == 1,
    disp('Starting wiberg_mean...');
    %profile on;
    %[U,V,mu] = wiberg_mean_naive(Y, H, r, Uini, Vini, mu_ini);
    [U,V,mu] = wiberg_mean(Y, H, r, Vini, mu_ini);
    disp('complete.');
end

%Y - U*V.' - ones(m,1)*mu.'

