% Test datacheck_nomean and wiberg_nomean

m = 50;
n = 30;
r = 3;
sigma = 0.01;

% Generate data
U0 = randn(m, r);
V0 = randn(n, r);
Y = U0 * V0.' + sigma*rand(m, n);
H = ones(m, n);

% Assume band-diagonal nonmissing components
band_width = 3;
for i=1:m
    for j=1:n
        if n/m*i-band_width*r < j && j < n/m*i+band_width*r,
            H(i,j) = 1;
        else
            H(i,j) = 0;
        end
    end
end

%H

% Initial values
Vini = randn(n, r);

disp('Checking the completeness of H...');
data_ok = datacheck_nomean(H, r);
disp('done.');
if data_ok == 1,
    disp('Starting wiberg_nomean...');
    %profile on;
    [U,V] = wiberg_nomean(Y, H, r, Vini);
    %[U,V] = wiberg_nomean_naive(Y, H, r, Uini, Vini, 1e-6, 30);
    disp('complete.');
end

%Y - U*V.'

